package asct.ui;

import java.util.Iterator;
import java.util.LinkedList;

/**
 * This class is an abstraction of some key fields of the execution request 
 * descriptor file. It represents the component element in the Composite Pattern.
 */
public class ExecutionRequestDescriptorComponent {
	
	private String applicationArguments;
	private LinkedList<String> inputFile;
	private LinkedList<String> outputFile;
	
	public String getApplicationArguments() {
		return applicationArguments;
	}

	public void setApplicationArguments(String applicationArguments) {
		this.applicationArguments = applicationArguments;
	}
	
	public Iterator<String> getInputFiles() {
		return inputFile.iterator();
	}

	public void addInputFile(String inputFile) {
		this.inputFile.add(inputFile);
	}

	public Iterator<String> getOutputFiles() {
		return outputFile.iterator();
	}

	public void addOutputFile(String outputFile) {
		this.outputFile.add(outputFile);
	}
}
