package asct.ui;

import java.util.Iterator;
import java.util.LinkedList;

import dataTypes.ApplicationType;

/**
 * This class is an abstraction of the execution request 
 * descriptor file. It represents the composite element 
 * in the Composite Pattern.
 * @author randrade
 *
 */
public class ExecutionRequestDescriptorComposite extends ExecutionRequestDescriptorComponent{
	
	private String applicationName;
	private ApplicationType applicationType; 
	private String applicationBasePath;
	private String applicationBinaries;
	private String applicationConstraints;
	private String applicationPreferences;
	private int numberOfTasks;
	private LinkedList<ExecutionRequestDescriptorComponent> parametricApplicationCopies;
	
	/**
	 * A default constructor
	 */
	ExecutionRequestDescriptorComposite(){
	}
	
	public String getApplicationName() {
		return applicationName;
	}

	public void setApplicationName(String applicationName) {
		this.applicationName = applicationName;
	}
	
	public ApplicationType getApplicationType() {
		return applicationType;
	}

	public void setApplicationType(ApplicationType applicationType) {
		this.applicationType = applicationType;
	}

	public String getApplicationBasePath() {
		return applicationBasePath;
	}

	public void setApplicationBasePath(String applicationBasePath) {
		this.applicationBasePath = applicationBasePath;
	}

	public String getApplicationBinaries() {
		return applicationBinaries;
	}

	public void setApplicationBinaries(String applicationBinaries) {
		this.applicationBinaries = applicationBinaries;
	}

	public String getApplicationConstraints() {
		return applicationConstraints;
	}

	public void setApplicationConstraints(String applicationConstraints) {
		this.applicationConstraints = applicationConstraints;
	}

	public String getApplicationPreferences() {
		return applicationPreferences;
	}

	public void setApplicationPreferences(String applicationPreferences) {
		this.applicationPreferences = applicationPreferences;
	}

	public int getBspNumberOfTasks() {
		return numberOfTasks;
	}

	public void setBspNumberOfTasks(int bspNumberOfTasks) {
		numberOfTasks = bspNumberOfTasks;
	}

	public int getMpiNumberOfTasks() {
		return numberOfTasks;
	}

	public void setMpiNumberOfTasks(int mpiNumberOfTasks) {
		numberOfTasks = mpiNumberOfTasks;
	}

	public Iterator<ExecutionRequestDescriptorComponent> getParametricApplicationCopies() {
		return parametricApplicationCopies.iterator();
	}

	public void addParametricApplicationCopies(
			ExecutionRequestDescriptorComponent applicationCopy) {
		this.parametricApplicationCopies.add(applicationCopy);
	}
	
}
